From oracle-l-bounce@freelists.org  Tue Mar  1 14:08:06 2005
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air891.startdedicated.com (root@localhost)
 by orafaq.com (8.12.10/8.12.10) with ESMTP id j21K86pR004968
 for <oracle-l@orafaq.com>; Tue, 1 Mar 2005 14:08:06 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air891.startdedicated.com (8.12.10/8.12.10) with ESMTP id j21K86em004964
 for <oracle-l@orafaq.com>; Tue, 1 Mar 2005 14:08:06 -0600
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id B4A607C111;
 Tue,  1 Mar 2005 14:06:41 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 17508-06; Tue, 1 Mar 2005 14:06:41 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 1B33A7C071;
 Tue,  1 Mar 2005 14:06:41 -0500 (EST)
Subject: Re: Transportable tablespace with missing datafile
From: Ken Payton <ken.payton@choicepointprg.net>
To: scott.hutchinson@interact-analysis.com
Cc: Oracle-L <oracle-l@freelists.org>
In-Reply-To: <1109700878.4224b10edaf6c@mopp.namemagic.com>
References: <1109700878.4224b10edaf6c@mopp.namemagic.com>
Content-type: text/plain
Content-Transfer-Encoding: 8bit
Organization: Choicepoint, Inc.
Message-Id: <1109703893.6790.265.camel@kpaytonlap.na.choicepoint.net>
Mime-Version: 1.0
Date: Tue, 01 Mar 2005 14:04:53 -0500
X-archive-position: 16773
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: ken.payton@choicepointprg.net
Precedence: normal
Reply-To: ken.payton@choicepointprg.net
X-list: oracle-l
X-Virus-Scanned: by amavisd-new-20030616-p9 (Debian) at avenirtech.net
X-Spam-Checker-Version: SpamAssassin 2.60 (1.212-2003-09-23-exp) on 
 air891.startdedicated.com
X-Spam-Status: No, hits=0.0 required=5.0 tests=none autolearn=ham version=2.60
X-Spam-Level: 

Scary thought.

I have editing my dump files in the past for other reasons, such as
renaming a tablespace, but intellectual curiosity forced me to test this
one and it actually worked.

Open your dump file in some binary file editor.  I use "vi -b" on Redhat
or Suse linux systems, I have not found this option on the version of vi
installed on our Unix(Solaris) systems.  Do not use vi alone, it will
translate some binary characters into ASCII and upon saving will hose
your dmp file.

Remove one from the 4th parameter of this line, this is the number of
datafiles in this TEST tablespace.  In this case stating there are only
3 files in the tablespace, not my original 4.

EXECTRP
sys.dbms_plugts.beginImpTablespace('TEST',57,'SYS',3,0,16384,1,12501998862,1,2147483645,64,64,64,0,1,0,64,2064877929,1,2,12501808311,NULL,0,0,NULL,NULL);

Remove the line corresponding to the missing datafile.  3rd parameter
appears to be file_id.  You might be able to detect this by which file
imp is currently telling you is missing.

EXECTRP
sys.dbms_plugts.checkDatafile(NULL,2064877929,96,640,57,96,0,0,12501808335,12501998862,1,402653186,NULL,NULL,NULL);

import your tablespace excluding the missing file from the datafiles
parameter.


I tested this on 8.1.7 and it worked.  I was also able to read data
until I hit the missing file.  For my test I created a tablespace with 4
10MB datafiles.  I then created a table that was 34MB in size ensuring I
had data in each file.  I dropped the tablespace and reimported the
tablespace using the above instructions.  The tablespace imported
without problem and allowed select's against the table, although a
select count caused a ORA-0600.


If you're looking for a solution to get the data back from the missing
file you might try restoring the file from the backup, modifying the
CheckDatafile's SCN to match that of the SCN in the file header.  This
would take a little more testing/digging but I would be willing to bet
$5 it would work.  Of course if the data is not worth $5 I wouldn't
waste the effort.

Kenny

On Tue, 2005-03-01 at 13:14, scott.hutchinson@interact-analysis.com
wrote:
> All,
> 
> Does anyone know any tricks for forcing a transportable tablespace to "import" 
> when a datafile is missing?  I don't mind loosing the data within this 
> datafile, but there are many other valuable tables in other datafiles within 
> this tablespace.
> 
> Due to an operational error, 1 file (out of 91) from a 2tb tablespace has been 
> deleted after the metadata was exported.  We have a cold backup of the 
> datafiles from this tablespace only (not full DB) but the tablespace was NOT 
> readonly at the point of the backup, and the database was restarted for the 
> metadata export. This means we can not simply restore the missing file.
> 
> The error we get on import is ORA-19722, and the oracle version is 9.2.0.5.
> 
> Thanks,
> Scott.
> 
> ::This message sent using the free Web Mail service from http://TheName.co.uk
> --
> http://www.freelists.org/webpage/oracle-l
-- 
Kenny Payton
Software Architect
Public Records Group, Boca Raton
Choicepoint, Inc.
ken.payton@choicepointprg.net
o: (770)752-4054
c: (561)926-4119
--
http://www.freelists.org/webpage/oracle-l

